#
create_clock -name CLK50MO -period 20 [get_ports CLK50M]

create_generated_clock -name CLK66M -source [get_ports CLK50M] \
  -divide_by  3 -multiply_by 4 "U_CLKGEN|U_PLL66M100M|altpll_component|auto_generated|pll1|clk[0]"

create_generated_clock -name CLK100M -source [get_ports CLK50M] \
  -divide_by  1 -multiply_by 2 "U_CLKGEN|U_PLL66M100M|altpll_component|auto_generated|pll1|clk[1]"

create_generated_clock -name CLK100M_DI -source [get_ports CLK50M] \
  -divide_by  1 -multiply_by 2 "U_CLKGEN|U_PLL66M100M|altpll_component|auto_generated|pll1|clk[2]" -phase 90

create_generated_clock -name SDRAM_CLK \
-source "U_CLKGEN|U_PLL66M100M|altpll_component|auto_generated|pll1|clk[1]" [get_ports DRAM_CLK]

set_clock_uncertainty -from CLK50MO -to CLK50MO 0.2
set_clock_uncertainty -from CLK66M  -to CLK66M  0.2
set_clock_uncertainty -from CLK100M -to CLK100M 0.2
set_clock_uncertainty -from CLK100M_DI -to CLK100M_DI 0.2

set_clock_uncertainty -from CLK100M    -to SDRAM_CLK  0.2
set_clock_uncertainty -from SDRAM_CLK  -to CLK100M    0.2
set_clock_uncertainty -from SDRAM_CLK  -to CLK100M_DI 0.2

#
set_false_path -from [get_clocks CLK66M]  -to [get_clocks CLK100M]
set_false_path -from [get_clocks CLK66M]  -to [get_clocks CLK100M_DI]
set_false_path -from [get_clocks CLK66M]  -to [get_clocks CLK50MO]

set_false_path -from [get_clocks CLK100M] -to [get_clocks CLK66M]
set_false_path -from [get_clocks CLK100M] -to [get_clocks CLK100M_DI]
set_false_path -from [get_clocks CLK100M] -to [get_clocks CLK50MO]

set_false_path -from [get_clocks CLK50MO]  -to [get_clocks CLK66M]
set_false_path -from [get_clocks CLK50MO]  -to [get_clocks CLK100M]
set_false_path -from [get_clocks CLK50MO]  -to [get_clocks CLK100M_DI]

set_false_path -from [get_clocks CLK100M_DI]  -to [get_clocks CLK66M]
set_false_path -from [get_clocks CLK100M_DI]  -to [get_clocks CLK100M]
set_false_path -from [get_clocks CLK100M_DI]  -to [get_clocks CLK50MO]

#
#set_output_delay -clock CLK14M -max 5 [all_outputs]
#set_output_delay -clock CLK16M -max 5 [all_outputs]

set_output_delay -clock SDRAM_CLK -max 1.0 [get_ports DRAM_A*]
set_output_delay -clock SDRAM_CLK -max 1.0 [get_ports DRAM_D*]
set_output_delay -clock SDRAM_CLK -max 1.0 [get_ports DRAM_CS_N]
set_output_delay -clock SDRAM_CLK -max 1.0 [get_ports DRAM_RAS_N]
set_output_delay -clock SDRAM_CLK -max 1.0 [get_ports DRAM_CAS_N]
set_output_delay -clock SDRAM_CLK -max 1.0 [get_ports DRAM_WE_N]
set_output_delay -clock SDRAM_CLK -max 1.0 [get_ports DRAM_CKE]

set_output_delay -clock SDRAM_CLK -min 0.0 [get_ports DRAM_A*]
set_output_delay -clock SDRAM_CLK -min 0.0 [get_ports DRAM_D*]
set_output_delay -clock SDRAM_CLK -min 0.0 [get_ports DRAM_CS_N]
set_output_delay -clock SDRAM_CLK -min 0.0 [get_ports DRAM_RAS_N]
set_output_delay -clock SDRAM_CLK -min 0.0 [get_ports DRAM_CAS_N]
set_output_delay -clock SDRAM_CLK -min 0.0 [get_ports DRAM_WE_N]
set_output_delay -clock SDRAM_CLK -min 0.0 [get_ports DRAM_CKE]


# wire delay(0.25ns) + SDRAM output delay(6ns) + wire delay(0.25ns)
set_input_delay -clock SDRAM_CLK -max 6.5 [get_ports DRAM_D*]
set_input_delay -clock SDRAM_CLK -min 0.7 [get_ports DRAM_D*]
#set_input_delay -clock SDRAM_CLK -min 0.5 [get_ports DRAM_D*]

set_multicycle_path -end -setup -from SDRAM_CLK -to CLK100M_DI 2


