--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity CTRLROM_WRAP is
	port (
		ADDRESS	: in  std_logic_vector(15 downto 0);
		DATA	: in  std_logic_vector(7 downto 0);
		RDN		: in  std_logic;
		WRN		: in  std_logic;
		CLK		: in  std_logic;
		RSTN	: in  std_logic;
		Q		: out std_logic_vector(7 downto 0)
	);
end CTRLROM_WRAP;

architecture RTL of CTRLROM_WRAP is

	component CTRLROM is
		port (
			aclr	: in  std_logic;
			address	: in  std_logic_vector(15 downto 0);
			clock	: in  std_logic;
			data	: in  std_logic_vector(7 downto 0);
			wren	: in  std_logic;
			q		: out std_logic_vector(7 downto 0)
		);
	end component;

	signal aclr		: std_logic;
	signal wren		: std_logic;
	signal q_i		: std_logic_vector(7 downto 0);

begin
	aclr <= not RSTN;

	wren <= not WRN;

	U_CTRLROM : CTRLROM
	port map (
		aclr	=> aclr,
		address	=> ADDRESS,
		clock	=> CLK,
		data    => DATA,
		wren    => wren,
		q		=> q_i
	);

	Q <= q_i;

end RTL;
