@echo off

set SDCC_PATH="sdcc\bin"
set DISAS_EXE="hoja\hoja"

set WORK=work\

rem -------------------------
rem copy source file
rem -------------------------

copy _divulong.c	%WORK%
copy _mullong.c		%WORK%
copy _mulint.c		%WORK%
copy _strcmp.c		%WORK%
copy _strncat.c		%WORK%
copy sprintf.c		%WORK%
copy printf_large.c	%WORK%
copy ioreg.s		%WORK%
copy strlen.s		%WORK%
copy __sdcc_call_hl.s	%WORK%
copy crt0.s			%WORK%
copy sndrcv.s		%WORK%
copy spi.s			%WORK%

copy avr_mmcp.c		%WORK%
copy diskio.h		%WORK%
copy pff.c			%WORK%
copy pff.h			%WORK%
copy pffconf.h		%WORK%

copy nanocart.h		%WORK%
copy spi.h			%WORK%

copy oled.h			%WORK%
copy oled.c			%WORK%
copy font8x12.h		%WORK%
copy verdata.h		%WORK%

copy pc6031.c		%WORK%
copy pc6031.h		%WORK%
copy main.c			%WORK%


rem -------------------------
rem compile library
rem -------------------------

set TRG=_divulong
echo %TRG%.c
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=_mullong
echo %TRG%.c
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=_mulint
echo %TRG%.c
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=_strcmp
echo %TRG%.c
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=_strncat
echo %TRG%.c
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=sprintf
echo %TRG%.c
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=printf_large
echo %TRG%.c
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..


rem -------------------------------
rem compile assembler source
rem -------------------------------

set TRG=crt0
echo %TRG%.s
cd %WORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=ioreg
echo %TRG%.s
cd %WORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=strlen
echo %TRG%.s
cd %WORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=__sdcc_call_hl
echo %TRG%.s
cd %WORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=sndrcv
echo %TRG%.s
cd %WORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=spi
echo %TRG%.s
cd %WORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..


rem --------------------------
rem compile C source
rem --------------------------

set TRG=avr_mmcp
echo %TRG%
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=pff
echo %TRG%
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=oled
echo %TRG%
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=main
echo %TRG%
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..

set TRG=pc6031
echo %TRG%
cd %WORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..


rem --------------------------
rem linkall
rem --------------------------

echo link
cd %WORK%
%SDCC_PATH%\sdcc -mz80 --no-std-crt0 --nostdlib --nostdinc --code-loc 0x0100 --data-loc 0xb000 crt0.rel _divulong.rel _mullong.rel _mulint.rel _strcmp.rel _strncat.rel sprintf.rel printf_large.rel avr_mmcp.rel pff.rel ioreg.rel sndrcv.rel  strlen.rel __sdcc_call_hl.rel spi.rel oled.rel pc6031.rel main.rel
copy /y crt0.ihx ..\..\src\ctrlrom.hex
cd ..

rem ---------------------------------------
rem convert intel-HEX to binary (for debug)
rem ---------------------------------------

echo makebin
cd %WORK%
%SDCC_PATH%\makebin -s 49152 crt0.ihx crt0.bin
%DISAS_EXE% -o0 -u -h -l0 crt0.bin > crt0.asm
cd ..

