;--------------------------------------------------------------------------
;  crt0.s - Generic crt0.s for a Z80
;
;  Copyright (C) 2000, Michael Hope
;
;  This library is free software; you can redistribute it and/or modify it
;  under the terms of the GNU General Public License as published by the
;  Free Software Foundation; either version 2, or (at your option) any
;  later version.
;
;  This library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License 
;  along with this library; see the file COPYING. If not, write to the
;  Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston,
;   MA 02110-1301, USA.
;
;  As a special exception, if you link this library with other files,
;  some of which are compiled with SDCC, to produce an executable,
;  this library does not by itself cause the resulting executable to
;  be covered by the GNU General Public License. This exception does
;  not however invalidate any other reasons why the executable file
;   might be covered by the GNU General Public License.
;--------------------------------------------------------------------------

	.module crt0
	.globl	_main

	.area	_HEADER (ABS)

	.org	0x0000
	jp	init

	.org	0x0004
	.dw	#int04_sub

	.org	0x0006
int04_jptbl:
	.dw	0x0038

	.org	0x0038
	di
1$:	jr	1$


int04_sub:
	push	af
	push	bc
	push	de
	push	hl
	push	ix
	push	iy

	ld	hl,#1$
	push	hl
	ld	hl,(#int04_jptbl)
	jp	(hl)
1$:
	pop	iy
	pop	ix
	pop	hl
	pop	de
	pop	bc
	pop	af
	ei
	ret

	.area	_CODE
init::
	ld	sp,#0xc000

	call	gsinit
	call	_main
1$:	jr	1$

	;; Ordering of segments for the linker.
	.area	_HOME
	.area	_CODE
	.area	_DATA
	.area	_INITIALIZED
	.area   _HEAP
	.area   _HEAP_END

	.area	_INITIALIZER
	.area   _GSINIT
	.area   _GSFINAL

	.area   _GSINIT
gsinit::

	ld	hl, #s__DATA
	ld	bc, #l__DATA
_clear_loop:
	ld	(hl), #0
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,_clear_loop

	ld	bc, #l__INITIALIZER
	ld	a, b
	or	a, c
	jr	z, gsinit_next
	ld	de, #s__INITIALIZED
	ld	hl, #s__INITIALIZER
	ldir
gsinit_next:

	.area   _GSFINAL
	ret

