
#ifndef _NANOCART_DEFINED
#define _NANOCART_DEFINED

#include "pff.h"

#define	VER_NO		"125"		/* o[Wԍ */
#define	MODEL_NO	"NC"		/* @ԍ */
#define	HW_VERNO	peek(HW_VERH), peek(HW_VERL)	/* n[hEGAԍ */

#define	PC6031_USE_QBYTE		1		/* 4oCg] use */
#define	PC6031_USE_OLED			1		/* OLED use */
#define	PC6031_OLED_USE_I2C		1		/* I2C use */
#define	PC6031_ROM_USE			1		/* ROM use */

#define	LEDG_ON()		poke(LEDG, 0x01)		/* LEDΓ_ */
#define	LEDG_OFF()		poke(LEDG, 0x00)		/* LEDΏ */
#define	LEDR_ON()		poke(LEDR, 0x01)		/* LEDԓ_ */
#define	LEDR_OFF()		poke(LEDR, 0x00)		/* LEDԏ */

#define	IS_P6_RESET		!(peek(RSTP6N) & 0x01)		/* P6ZbgH */

#define	IS_ATN_HIGH		(PIO_C_IN() & 0x08)		/* MATNHH */
#define	IS_DAC_HIGH		(PIO_C_IN() & 0x04)		/* MDACHH */
#define	IS_RFD_HIGH		(PIO_C_IN() & 0x02)		/* MRFDHH */
#define	IS_DAV_HIGH		(PIO_C_IN() & 0x01)		/* MDAVHH */

#define	IS_ATN_LOW		!(PIO_C_IN() & 0x08)	/* MATNLH */
#define	IS_DAC_LOW		!(PIO_C_IN() & 0x04)	/* MDACLH */
#define	IS_RFD_LOW		!(PIO_C_IN() & 0x02)	/* MRFDLH */
#define	IS_DAV_LOW		!(PIO_C_IN() & 0x01)	/* MDAVLH */

#define	ATN_HIGH()		poke(PIO_CNT, 0x0f)		/* MATNHɂ */
#define	DAC_HIGH()		poke(PIO_CNT, 0x0d)		/* MDACHɂ */
#define	RFD_HIGH()		poke(PIO_CNT, 0x0b)		/* MRFDHɂ */
#define	DAV_HIGH()		poke(PIO_CNT, 0x09)		/* MDAVHɂ */

#define	ATN_LOW()		poke(PIO_CNT, 0x0e)		/* MATNLɂ */
#define	DAC_LOW()		poke(PIO_CNT, 0x0c)		/* MDACLɂ */
#define	RFD_LOW()		poke(PIO_CNT, 0x0a)		/* MRFDLɂ */
#define	DAV_LOW()		poke(PIO_CNT, 0x08)		/* MDAVLɂ */

#define	PIO_A_IN_B_IN()		poke(PIO_CNT, 0x93)	/* |[gÁA|[gB͂ɂ */
#define	PIO_A_IN_B_OUT()	poke(PIO_CNT, 0x91)	/* |[gÁA|[gBo͂ɂ */
#define	PIO_A_OUT_B_OUT()	poke(PIO_CNT, 0x81)	/* |[gAóA|[gBo͂ɂ */

#define	SND_B(d)		poke(PIO_B, d)			/* f[^𑗐M(|[gB) */
#define	RCV_A			peek(PIO_A)				/* f[^M(|[gA) */
#define	SND_A(d)		poke(PIO_A, d)			/* f[^𑗐M(|[gA) */
#define	RCV_B			peek(PIO_B)				/* f[^M(|[gB) */

#define PIO_C_IN()		(peek(PIO_C) & 0x0f)	/* |[gCf[^͂ */
#define PIO_C_OUT()		poke(PIO_C, APPIC_OUT)	/* |[gCɃf[^o͂ */

#define	IS_TIMER_END	!(peek(TIM5S) & 0x01)		/* 5b^C}H */
#define	IS_SD_INSERT	!(peek(SD_EJECT) & 0x01)	/* SDJ[h}ĂH */
#define	IS_SD_EJECT		(peek(SD_EJECT) & 0x01)		/* SDJ[hĂH */
#define	IS_SD_WP		(peek(SD_WP) & 0x01) 		/* SDJ[hCgveNgH */

#define	SD_ENABLE()		poke(SD_OUTENB, 0x01)		/* SDJ[hL */
#define	SD_DISABLE()	poke(SD_OUTENB, 0x00)		/* SDJ[h𖳌 */
#define	IS_SD_ENABLE	(peek(SD_OUTENB) & 0x01)	/* SDJ[hLH */
#define	IS_SD_DISABLE	!(peek(SD_OUTENB) & 0x01)	/* SDJ[hH */

#define	REBOOT()		poke(RSTCARTN, 0x00)		/* ċN */

#define	RSTWAIT		15			/* Zbg҂ */

#define	INITDONE	0xf000		/* I */
#define	LEDG		0xf001		/* LEDΓ_/_ */
#define	LEDR		0xf002		/* LEDԓ_/_ */
#define	RAMDT		0xf003		/* ROM/RAM̈ւ̏݃f[^ */
#define	RAMADD		0xf004		/* ROM/RAM̈ւ̏݃AhX */
#define	RAMWRN		0xf007		/* ROM/RAM̈ւ̏݃pX */
#define	BANKDT		0xf008		/* ROM/RAM̃oNւ̏݃f[^ */
#define	BANKADD		0xf009		/* ROM/RAM̃oNւ̏݃AhX */
#define	BANKWRN		0xf00a		/* ROM/RAM̃oNւ̏݃pX */
#define	RAM_STREAM	0xf00b		/* ROM/RAM̈ւ̘A */
#define	USEROM		0xf00c		/* P6ZbgAROMoNɐݒ肷 */

#define	USIDR		0xf010		/* SPIpS/Pւ̓ǂݏf[^ */
#define	USISFT		0xf011		/* SPIpS/Pւ̃NbNx8o */
#define	SD_CS		0xf012		/* SDւCSo */
#define	SD_OUTENB	0xf013		/* SDւ̏o̓Cl[u */
#define	SD_EJECT	0xf014		/* SDJ[h̗L */
#define	SD_WP		0xf015		/* SDJ[h̃CgveNg */
#define	TIM100US	0xf016		/* 100us^C} */
#define	TIMNX10MS	0xf017		/* Nx10ms ^C} */
#define	TIMNX10		0xf018		/* Nx10ms^C}iNݒj */
#define	TIM5S		0xf019		/* 5s   ^C}#1 */
#define	I2CDATA_EP	0xf01a		/* EEPROMpI2Cf[^ */
#define	I2CCTRL_EP	0xf01b		/* EEPROMpI2Cib3:START b2:STOP b1:R/W(1=R) b0FJn,Ij */
#define	I2CDATA_OL	0xf01c		/* OLEDpI2Cf[^ */
#define	I2CCTRL_OL	0xf01d		/* OLEDpI2Cib3:START b2:STOP b1:R/W(1=R) b0FJn,Ij */

#define	RSTP6N		0xf020		/* P6Zbg */
#define	RSTCARTN	0xf021		/* J[gbWZbg */
#define	OLED_CS		0xf022		/* OLEDւCSo */
#define	OLED_RST	0xf023		/* OLEDւRSTo */
#define	OLED_DC		0xf024		/* OLEDւDCo */
#define	OLED_I2C	0xf025		/* OLEDʁi1=I2Cj */

#define	HW_VERH		0xf07e		/* HW o[Wԍ */
#define	HW_VERL		0xf07f		/* HW o[Wԍ */

#define	PIO_A		0xf080		/* 8255 |[gA */
#define	PIO_B		0xf081		/* 8255 |[gB */
#define	PIO_C		0xf082		/* 8255 |[gC */
#define	PIO_CNT		0xf083		/* 8255 |[g */

#define	OLED_START	0x01		/* OLED Jn */
#define	OLED_END	0x02		/* OLED I */
#define	OLED_INV	0x03		/* OLED ] */
#define	OLED_NOINV	0x04		/* OLED ]߂ */

BYTE peek(UINT);				/* memory (io) read  */
void poke(UINT, BYTE);			/* memory (io) write */
void _delay_ms(int);			/* Nms  ҂ */
void TIMER2_OVF(void);			/* TIMER2 over interrupt */

#endif /* _NANOCART_DEFINED */
