;
; 8255 I/F
;

TIM5S		.equ	0xf019		; 5s ^C}#1
RSTP6N		.equ	0xf020		; P6Zbg
PIO_A		.equ	0xf080		; 8255 |[gA
PIO_B		.equ	0xf081		; 8255 |[gB
PIO_C		.equ	0xf082		; 8255 |[gC
PIO_CNT		.equ	0xf083		; 8255 |[g
DAC_MASK	.equ	0x04		; DACo
RFD_MASK	.equ	0x02		; RFDo
DAV_MASK	.equ	0x01		; DAVo
DAC_SET		.equ	0x0d		; DACHɂ
RFD_SET		.equ	0x0b		; RFDHɂ
DAV_SET		.equ	0x09		; DAVHɂ
DAC_RESET	.equ	0x0c		; DACLɂ
RFD_RESET	.equ	0x0a		; RFDLɂ
DAV_RESET	.equ	0x08		; DAVLɂ
PIOAINBIN	.equ	0x93		; PIÕ|[gÁABo͂ɂ
PIOAINBOUT	.equ	0x91		; PIÕ|[gÁAB͂ɂ
PIOAOUTBOUT	.equ	0x81		; PIÕ|[gAóABo͂ɂ

; /* PIO */
; void _P6PIO_init(void)
;
	.area	_CODE
__P6PIO_init::
	ld	a,#PIOAINBOUT
	ld	(PIO_CNT),a	; PIO_A_IN_B_OUT();
	xor	a
	ld	(PIO_B),a	; SND_B(0x00);
	ld	(PIO_C),a	; PIO_C_OUT(0x00);

	ld	hl,#0x0001	; PIO_error = 1
	ret

;
; /* 2oCgf[^M */
; BYTE _P6PIO_sendw(BYTE dt1, BYTE dt2)
;
; RETURN => PIO_error
;
	.area	_CODE
__P6PIO_sendw::
	ld	hl,#2
	add	hl,sp

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
1$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#RFD_MASK
	jr	z,1$		; while ( IS_RFD_LOW ) {

	ld	a,(hl)
	ld	(PIO_B),a	; SND_B(dt1);

	ld	a,#DAV_SET
	ld	(PIO_CNT),a	; DAV_HIGH();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
2$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAC_MASK
	jr	z,2$		; while ( IS_DAC_LOW ) {

	inc	hl
	ld	a,(hl)
	ld	(PIO_B),a	; SND_B(dt2);

	ld	a,#DAV_RESET
	ld	(PIO_CNT),a	; DAV_LOW();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
3$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAC_MASK
	jr	nz,3$		; while ( IS_DAC_HIGH ) {

	ld	hl,#0		; PIO_error = 0
	ret

; /* 4oCgf[^MO */
; BYTE _P6PIO_sendq_pre(void)
;
; RETURN => PIO_error
;
	.area	_CODE
__P6PIO_sendq_pre::
	ld	a,#PIOAOUTBOUT
	ld	(PIO_CNT),a	; PIO_A_OUT_B_OUT();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
1$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#RFD_MASK
	jr	z,1$		; while ( IS_RFD_LOW ) {

	ld	hl,#0		; PIO_error = 0
	ret

; /* 4oCgf[^M */
; BYTE _P6PIO_sendq(BYTE dt1, BYTE dt2, BYTE dt3, BYTE dt4)
;
; RETURN => PIO_error
;
	.area	_CODE
__P6PIO_sendq::
	ld	hl,#2
	add	hl,sp

	ld	a,(hl)
	ld	(PIO_B),a	; SND_B(dt1);

	inc	hl
	ld	a,(hl)
	ld	(PIO_A),a	; SND_A(dt2);

	ld	a,#DAV_SET
	ld	(PIO_CNT),a	; DAV_HIGH();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
1$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAC_MASK
	jr	z,1$		; while ( IS_DAC_LOW ) {

	inc	hl
	ld	a,(hl)
	ld	(PIO_B),a	; SND_B(dt3);

	inc	hl
	ld	a,(hl)
	ld	(PIO_A),a	; SND_A(dt4);

	ld	a,#DAV_RESET
	ld	(PIO_CNT),a	; DAV_LOW();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
2$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAC_MASK
	jr	nz,2$		; while ( IS_DAC_HIGH ) {

	ld	hl,#0		; PIO_error = 0
	ret


; /* 2oCgf[^M */
; BYTE _P6PIO_receivew(BYTE *dt1, BYTE *dt2)
;
; RETURN => PIO_error
;
	.area	_CODE
__P6PIO_receivew::
	ld	hl,#2
	add	hl,sp

	ld	a,#RFD_SET
	ld	(PIO_CNT),a	; RFD_HIGH();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
1$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAV_MASK
	jr	z,1$		; while ( IS_DAV_LOW ) {

	ld	a,#RFD_RESET
	ld	(PIO_CNT),a	; RFD_LOW();

	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	a,(PIO_A)
	ld	(de),a		; *dt1 = RCV_A;

	ld	a,#DAC_SET
	ld	(PIO_CNT),a	; DAC_HIGH();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
2$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAV_MASK
	jr	nz,2$		; while ( IS_DAV_HIGH ) {

	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	a,e
	or	d
	jr	z,5$		; if (dt2) {

	ld	a,(PIO_A)
	ld	(de),a		; *dt2 = RCV_A;
5$:

	ld	a,#DAC_RESET
	ld	(PIO_CNT),a	; DAC_LOW();

	ld	hl,#0		; PIO_error = 0
	ret

; /* 4oCgf[^MO */
; BYTE _P6PIO_receiveq_pre(void)
;
; RETURN => PIO_error
;
	.area	_CODE
__P6PIO_receiveq_pre::
	ld	a,#PIOAINBIN
	ld	(PIO_CNT),a	; PIO_A_IN_B_IN();

	ld	a,#RFD_SET
	ld	(PIO_CNT),a	; RFD_HIGH();

	ld	hl,#0		; PIO_error = 0
	ret

; /* 4oCgf[^M */
; BYTE _P6PIO_receiveq(BYTE *dt1, BYTE *dt2, BYTE *dt3, BYTE *dt4)
;
; RETURN => PIO_error
;
	.area	_CODE
__P6PIO_receiveq::
	ld	hl,#2
	add	hl,sp

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
1$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAV_MASK
	jr	z,1$		; while ( IS_DAV_LOW ) {

	ld	a,#RFD_RESET
	ld	(PIO_CNT),a	; RFD_LOW();

	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	a,(PIO_A)
	ld	(de),a		; *dt1 = RCV_A;

	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	a,(PIO_B)
	ld	(de),a		; *dt2 = RCV_B;

	ld	a,#DAC_SET
	ld	(PIO_CNT),a	; DAC_HIGH();

	ld	a,#0x01
	ld	(TIM5S),a	; TIMER_START();
2$:
	ld	a,(TIM5S)
	ld	e,a
	ld	a,(RSTP6N)
	and	e
	and	#0x01		; if ( IS_TIMER_END || IS_P6_RESET ) {
	jp	z,__P6PIO_init

	ld	a,(PIO_C)
	and	#DAV_MASK
	jr	nz,2$		; while ( IS_DAV_HIGH ) {

	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	a,(PIO_A)
	ld	(de),a		; *dt3 = RCV_A;

	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	a,(PIO_B)
	ld	(de),a		; *dt4 = RCV_B;

	ld	a,#DAC_RESET
	ld	(PIO_CNT),a	; DAC_LOW();

	ld	hl,#0		; PIO_error = 0
	ret

