;
; SPI
;

RAM_STREAM	.equ	0xf00b		; ROM/RAM̈ւ̘A
USIDR		.equ	0xf010		; SPIpS/Pւ̓ǂݏf[^i݂S/PJnj
USISFT		.equ	0xf011		; SPIANZXpS/P̓쒆i쒆"1hj

; /* Initialize SPI control ports */
; void init_spi(void)
;
	.area	_CODE
_init_spi::

	ret

; /* Send a byte to the SPI */
; void xmit_spi(BYTE d)
;
	.area	_CODE
_xmit_spi::

	ld	hl,#2
	add	hl,sp

	ld	a,(hl)
	ld	(USIDR),a		; poke(USIDR, d);
1$:
	ld	a,(USISFT)
	rrca
	jp	c,1$			; while ( (peek(USISFT) & 0x01) ) {

	ret


; /* Send a 0xFF to the SPI and get the received byte */
; BYTE rcv_spi(void)
;
	.area	_CODE
_rcv_spi::

	ld	a,#0xff
	ld	(USIDR),a		; poke(USIDR, 0xff);
1$:
	ld	a,(USISFT)
	rrca
	jp	c,1$			; while ( (peek(USISFT) & 0x01) ) {

	ld	a,(USIDR)		; return peek(USIDR);
	ld	l,a
	ld	h,#0
	ret


; /* Receive a part of the sector */
; void rcv_sector(UINT offset, UINT count, BYTE *buff)
; 
;	bc = 512 + 2 - offset - count;	/* Number of trailing bytes to skip */
;
;	/* Skip leading bytes in the sector */
;	while (offset--) rcv_spi();
;
;	/* Receive a part of the sector */
;	if (buff) {	/* Store data to the memory */
;		do {
;			*buff++ = rcv_spi();
;		} while (--count);
;	} else {	/* Forward data to the outgoing stream */
;		do {
;			FORWARD(rcv_spi());
;		} while (--count);
;	}
;
;	/* Skip trailing bytes in the sector and block CRC */
;	do rcv_spi(); while (--bc);


	.area	_CODE
_rcv_sector::
	ld	hl,#2
	add	hl,sp

	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	e,c
	ld	d,b
				; bc = offset
				; de = offset

2$:
	ld	a,b
	or	c
	jr	z,3$
	dec	bc

	ld	a,#0xff
	ld	(USIDR),a	; poke(USIDR, 0xff);
1$:
	ld	a,(USISFT)
	rrca
	jp	c,1$		; while ( (peek(USISFT) & 0x01) ) {
	jp	2$
3$:

	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
				; de = offset
				; bc = count
	push	hl

	ld	hl,#514
	or	a
	sbc	hl,de		; hl = 512+2-offset
	sbc	hl,bc		; hl = 512+2-offset-count
	ex	de,hl		; de = 512+2-offset-count

	pop	hl

	inc	hl
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
				; hl = buff
				; bc = count
				; de = 512+2-offset-count

	ld	a,l
	or	h
	jr	z,10$

5$:
	ld	a,#0xff
	ld	(USIDR),a	; poke(USIDR, 0xff);
4$:
	ld	a,(USISFT)
	rrca
	jp	c,4$		; while ( (peek(USISFT) & 0x01) ) {

	ld	a,(USIDR)
	ld	(hl),a
	cpi			; buff++ ; count--
	jp	pe,5$		; while ( count )

12$:

7$:
	ld	a,#0xff
	ld	(USIDR),a	; poke(USIDR, 0xff);
6$:
	ld	a,(USISFT)
	rrca
	jp	c,6$		; while ( (peek(USISFT) & 0x01) ) {

	dec	de
	ld	a,d
	or	e
	jp	nz,7$

	ret


10$:
	ld	a,#0xff
	ld	(USIDR),a	; poke(USIDR, 0xff);
11$:
	ld	a,(USISFT)
	rrca
	jp	c,11$		; while ( (peek(USISFT) & 0x01) ) {

	ld	a,(USIDR)
	ld	(RAM_STREAM),a
	cpi			; buff++ ; count--
	jp	pe,10$		; while ( count )

	jp	12$

